com.fasterxml.jackson.databind.ser.std

## Class ObjectArraySerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.ContainerSerializer<T>
      - - com.fasterxml.jackson.databind.ser.std.ArraySerializerBase<Object[]>
        - - com.fasterxml.jackson.databind.ser.std.ObjectArraySerializer

All Implemented Interfaces:
  JsonFormatVisitable, SchemaAware, ContextualSerializer, Serializable

    public class ObjectArraySerializer
    extends ArraySerializerBase<Object[]>
    implements ContextualSerializer

Generic serializer for Object arrays (`Object[]`).

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

`JsonSerializer.None`

### Field Summary

Fields
`protected PropertySerializerMap` `_dynamicSerializers` If element type cannot be statically determined, mapping from runtime type to serializer is handled using this object
`protected JsonSerializer<Object>` `_elementSerializer` Value serializer to use, if it can be statically determined.
`protected JavaType` `_elementType` Declared type of element entries
`protected boolean` `_staticTyping` Whether we are using static typing (using declared types, ignoring runtime type) or not for elements.
`protected TypeSerializer` `_valueTypeSerializer` Type serializer to use for values, if any.

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.ArraySerializerBase

`_property, _unwrapSingle`

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_handledType`

### Constructor Summary

Constructors
Constructor and Description
`ObjectArraySerializer(JavaType elemType, boolean staticTyping, TypeSerializer vts, JsonSerializer<Object> elementSerializer)`
`ObjectArraySerializer(ObjectArraySerializer src, BeanProperty property, TypeSerializer vts, JsonSerializer<?> elementSerializer, Boolean unwrapSingle)`
`ObjectArraySerializer(ObjectArraySerializer src, TypeSerializer vts)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected JsonSerializer<Object>` `_findAndAddDynamic(PropertySerializerMap map, Class<?> type, SerializerProvider provider)`
`protected JsonSerializer<Object>` `_findAndAddDynamic(PropertySerializerMap map, JavaType type, SerializerProvider provider)`
`JsonSerializer<?>` `_withResolved(BeanProperty prop, Boolean unwrapSingle)`
`ContainerSerializer<?>` `_withValueTypeSerializer(TypeSerializer vts)` Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.
`void` `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType typeHint)` Default implementation specifies no format.
`JsonSerializer<?>` `createContextual(SerializerProvider serializers, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
`JsonSerializer<?>` `getContentSerializer()` Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically.
`JavaType` `getContentType()` Accessor for finding declared (static) element type for type this serializer is used for.
`boolean` `hasSingleElement(Object[] value)` Method called to determine if the given value (of type handled by this serializer) contains exactly one element.
`boolean` `isEmpty(SerializerProvider prov, Object[] value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
`void` `serialize(Object[] value, JsonGenerator gen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`void` `serializeContents(Object[] value, JsonGenerator gen, SerializerProvider provider)`
`void` `serializeContentsUsing(Object[] value, JsonGenerator jgen, SerializerProvider provider, JsonSerializer<Object> ser)`
`void` `serializeTypedContents(Object[] value, JsonGenerator jgen, SerializerProvider provider)`
`ObjectArraySerializer` `withResolved(BeanProperty prop, TypeSerializer vts, JsonSerializer<?> ser, Boolean unwrapSingle)`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.ArraySerializerBase

`_shouldUnwrapSingle, serializeWithType`

### Methods inherited from class com.fasterxml.jackson.databind.ser.ContainerSerializer

`hasContentTypeAnnotation, withValueTypeSerializer`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_neitherNull, _nonEmpty, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findContextualConvertingSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findIncludeOverrides, findPropertyFilter, getSchema, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

`getDelegatee, isEmpty, isUnwrappingSerializer, properties, replaceDelegatee, unwrappingSerializer, usesObjectId, withFilterId`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _staticTyping

    protected final boolean _staticTyping

Whether we are using static typing (using declared types, ignoring runtime type) or not for elements.

#### _elementType

    protected final JavaType _elementType

Declared type of element entries

#### _valueTypeSerializer

    protected final TypeSerializer _valueTypeSerializer

Type serializer to use for values, if any.

#### _elementSerializer

    protected JsonSerializer<Object> _elementSerializer

Value serializer to use, if it can be statically determined.

#### _dynamicSerializers

    protected PropertySerializerMap _dynamicSerializers

If element type cannot be statically determined, mapping from runtime type to serializer is handled using this object

### Constructor Detail

#### ObjectArraySerializer

    public ObjectArraySerializer(JavaType elemType,
                                 boolean staticTyping,
                                 TypeSerializer vts,
                                 JsonSerializer<Object> elementSerializer)

#### ObjectArraySerializer

    public ObjectArraySerializer(ObjectArraySerializer src,
                                 TypeSerializer vts)

#### ObjectArraySerializer

    public ObjectArraySerializer(ObjectArraySerializer src,
                                 BeanProperty property,
                                 TypeSerializer vts,
                                 JsonSerializer<?> elementSerializer,
                                 Boolean unwrapSingle)

### Method Detail

#### _withResolved

    public JsonSerializer<?> _withResolved(BeanProperty prop,
                                           Boolean unwrapSingle)

Specified by:
  `_withResolved` in class `ArraySerializerBase<Object[]>`

#### _withValueTypeSerializer

    public ContainerSerializer<?> _withValueTypeSerializer(TypeSerializer vts)

Description copied from class: `ContainerSerializer`
Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.

Specified by:
  `_withValueTypeSerializer` in class `ContainerSerializer<Object[]>`

#### withResolved

    public ObjectArraySerializer withResolved(BeanProperty prop,
                                              TypeSerializer vts,
                                              JsonSerializer<?> ser,
                                              Boolean unwrapSingle)

#### createContextual

    public JsonSerializer<?> createContextual(SerializerProvider serializers,
                                              BeanProperty property)
                                       throws JsonMappingException

Description copied from interface: `ContextualSerializer`
Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualSerializer`
Overrides:
  `createContextual` in class `ArraySerializerBase<Object[]>`
Parameters:
  `serializers` - Serializer provider to use for accessing config, other serializers
  `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
Returns:
  Serializer to use for serializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### getContentType

    public JavaType getContentType()

Description copied from class: `ContainerSerializer`
Accessor for finding declared (static) element type for type this serializer is used for.

Specified by:
  `getContentType` in class `ContainerSerializer<Object[]>`

#### getContentSerializer

    public JsonSerializer<?> getContentSerializer()

Description copied from class: `ContainerSerializer`
Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically. Note that for dynamic types this may return null; if so, caller has to instead use `ContainerSerializer.getContentType()` and `SerializerProvider.findValueSerializer(java.lang.Class<?>, com.fasterxml.jackson.databind.BeanProperty)`.

Specified by:
  `getContentSerializer` in class `ContainerSerializer<Object[]>`

#### isEmpty

    public boolean isEmpty(SerializerProvider prov,
                           Object[] value)

Description copied from class: `JsonSerializer`
Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

Default implementation will consider only null values to be empty.

NOTE: replaces `JsonSerializer.isEmpty(Object)`, which was deprecated in 2.5

Overrides:
  `isEmpty` in class `JsonSerializer<Object[]>`

#### hasSingleElement

    public boolean hasSingleElement(Object[] value)

Description copied from class: `ContainerSerializer`
Method called to determine if the given value (of type handled by this serializer) contains exactly one element.

Note: although it might seem sensible to instead define something like "getElementCount()" method, this would not work well for containers that do not keep track of size (like linked lists may not).

Note, too, that as of now (2.9) this method is only called by serializer itself; and specifically is not used for non-array/collection types like `Map` or `Map.Entry` instances.

Specified by:
  `hasSingleElement` in class `ContainerSerializer<Object[]>`

#### serialize

    public final void serialize(Object[] value,
                                JsonGenerator gen,
                                SerializerProvider provider)
                         throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles.

Overrides:
  `serialize` in class `ArraySerializerBase<Object[]>`
Parameters:
  `value` - Value to serialize; can not be null.
  `gen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`

#### serializeContents

    public void serializeContents(Object[] value,
                                  JsonGenerator gen,
                                  SerializerProvider provider)
                           throws IOException

Specified by:
  `serializeContents` in class `ArraySerializerBase<Object[]>`
Throws:
  `IOException`

#### serializeContentsUsing

    public void serializeContentsUsing(Object[] value,
                                       JsonGenerator jgen,
                                       SerializerProvider provider,
                                       JsonSerializer<Object> ser)
                                throws IOException

Throws:
  `IOException`

#### serializeTypedContents

    public void serializeTypedContents(Object[] value,
                                       JsonGenerator jgen,
                                       SerializerProvider provider)
                                throws IOException

Throws:
  `IOException`

#### acceptJsonFormatVisitor

    public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                                        JavaType typeHint)
                                 throws JsonMappingException

Description copied from class: `StdSerializer`
Default implementation specifies no format. This behavior is usually overriden by custom serializers.

Specified by:
  `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
Overrides:
  `acceptJsonFormatVisitor` in class `StdSerializer<Object[]>`
  `typeHint` - Type of element (entity like property) being visited
Throws:
  `JsonMappingException`

#### _findAndAddDynamic

    protected final JsonSerializer<Object> _findAndAddDynamic(PropertySerializerMap map,
                                                              Class<?> type,
                                                              SerializerProvider provider)
                                                       throws JsonMappingException

Throws:
  `JsonMappingException`

#### _findAndAddDynamic

    protected final JsonSerializer<Object> _findAndAddDynamic(PropertySerializerMap map,
                                                              JavaType type,
                                                              SerializerProvider provider)
                                                       throws JsonMappingException

Throws:
  `JsonMappingException`